
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Stock_movementsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const stock_movements = await db.stock_movements.create(
            {
                id: data.id || undefined,
        
        movement_type: data.movement_type
        ||
        null
            ,
            
        quantity: data.quantity
        ||
        null
            ,
            
        movement_time: data.movement_time
        ||
        null
            ,
            
        reason: data.reason
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await stock_movements.setStock_item( data.stock_item || null, {
            transaction,
        });
        
        await stock_movements.setRestaurant( data.restaurant || null, {
            transaction,
        });
        
        await stock_movements.setPerformed_by_user( data.performed_by_user || null, {
            transaction,
        });
        

        

        

        return stock_movements;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const stock_movementsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                movement_type: item.movement_type
            ||
            null
            ,
            
                quantity: item.quantity
            ||
            null
            ,
            
                movement_time: item.movement_time
            ||
            null
            ,
            
                reason: item.reason
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const stock_movements = await db.stock_movements.bulkCreate(stock_movementsData, { transaction });

        // For each item created, replace relation files
        

        return stock_movements;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const stock_movements = await db.stock_movements.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.movement_type !== undefined) updatePayload.movement_type = data.movement_type;
        
        
        if (data.quantity !== undefined) updatePayload.quantity = data.quantity;
        
        
        if (data.movement_time !== undefined) updatePayload.movement_time = data.movement_time;
        
        
        if (data.reason !== undefined) updatePayload.reason = data.reason;
        
        
        updatePayload.updatedById = currentUser.id;

        await stock_movements.update(updatePayload, {transaction});

        
        
        if (data.stock_item !== undefined) {
            await stock_movements.setStock_item(
              
              data.stock_item,
              
              { transaction }
            );
        }
        
        if (data.restaurant !== undefined) {
            await stock_movements.setRestaurant(
              
              data.restaurant,
              
              { transaction }
            );
        }
        
        if (data.performed_by_user !== undefined) {
            await stock_movements.setPerformed_by_user(
              
              data.performed_by_user,
              
              { transaction }
            );
        }
        

        
        

        

        return stock_movements;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const stock_movements = await db.stock_movements.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of stock_movements) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of stock_movements) {
                await record.destroy({transaction});
            }
        });


        return stock_movements;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const stock_movements = await db.stock_movements.findByPk(id, options);

        await stock_movements.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await stock_movements.destroy({
            transaction
        });

        return stock_movements;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const stock_movements = await db.stock_movements.findOne(
            { where },
            { transaction },
        );

        if (!stock_movements) {
            return stock_movements;
        }

        const output = stock_movements.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.stock_item = await stock_movements.getStock_item({
            transaction
        });
        
        
        output.restaurant = await stock_movements.getRestaurant({
            transaction
        });
        
        
        output.performed_by_user = await stock_movements.getPerformed_by_user({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.stock_items,
        as: 'stock_item',
        
        where: filter.stock_item ? {
          [Op.or]: [
            { id: { [Op.in]: filter.stock_item.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.stock_item.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.restaurants,
        as: 'restaurant',
        
        where: filter.restaurant ? {
          [Op.or]: [
            { id: { [Op.in]: filter.restaurant.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.restaurant.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.users,
        as: 'performed_by_user',
        
        where: filter.performed_by_user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.performed_by_user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.performed_by_user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.reason) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'stock_movements',
                        'reason',
                        filter.reason,
                    ),
                };
            }
            

            
            

            
            if (filter.quantityRange) {
                const [start, end] = filter.quantityRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    quantity: {
                    ...where.quantity,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    quantity: {
                    ...where.quantity,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.movement_timeRange) {
                const [start, end] = filter.movement_timeRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    movement_time: {
                    ...where.movement_time,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    movement_time: {
                    ...where.movement_time,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.movement_type) {
                where = {
                    ...where,
                movement_type: filter.movement_type,
            };
            }
            


      

      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.stock_movements.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'stock_movements',
                        'movement_type',
                        query,
                    ),
                ],
            };
        }

        const records = await db.stock_movements.findAll({
            attributes: [ 'id', 'movement_type' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['movement_type', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.movement_type,
        }));
    }

    
};

